<template>
  <div class="bookings">
    <!-- NAVBAR CONTENT -->
    <NavBar />

    <Notification />

    <div id="mainBody" class="container-fluid">
      <div id="mainHomeContent">
        <!-- MAIN HEADER CONTENT -->
        <MainHeader :main_text="mainHeader.main_text"
                    :sub_text="mainHeader.sub_text"/>

        <!-- HOURGLASS ICON -->
        <HourglassIcon v-if="page.showHourGlass" />

        <!-- EDIT CONFIRMATION WINDOW -->
        <ModalWindow v-if="page.showEdit" @close="page.showEdit = false" :title="edit_window.title" :body="edit_window.body">
          <div class="input-group mb-3">
            <span class="input-group-text" id="basic-addon3">
              <select v-model="selected" class="custom-select" name="edit" id="editParameter">
                <option value="pax">Number of Guests</option>
                <option value="name">Name</option>
                <option value="mobile">Mobile Number</option>
                <option value="notes">Additional Requests</option>
              </select>
            </span>
            <input v-model="edit_input" class="form-control" type="text" placeholder="Enter information here" aria-describedby="basic-addon3" required>
          </div>
          <div class="button-container">
            <button class="btn" @click="confirmEdit">Confirm Edit</button>
          </div>
          <div v-if="page.showInvalid.confirmEditBtn" class="invalid-entry">
            {{ invalid_note }}
          </div>
        </ModalWindow>

        <!-- DELETE CONFIRMATION WINDOW -->
        <ModalWindow v-if="page.showDelete" @close="page.showDelete = false"
                     :title="delete_window.title"
                     :body="delete_window.body">
          <div class="button-container">
            <button class="btn" @click="confirmDelete">Confirm Delete</button>
          </div>
        </ModalWindow>

        <!-- SERVER RESPONSE DISPLAY WINDOW -->
        <ModalWindow v-if="page.showResponse" @close="closeResponse"
                     :title="response_window.title"
                     :body="response_window.body">
          <div id="searchResult" class="row">
            <div class="pre-formatted col">{{ left_message }}</div>
            <div class="pre-formatted col">{{ right_message }}</div>
          </div>
        </ModalWindow>

        <!-- MIDDLE ROW CONTENT -->
        <div id="middleRow" class="row">
          <div class="card">

            <!-- Header -->
            <div class="row">
              <div class="card-header col">
                <h1>Upcoming Bookings</h1>
              </div>

              <!-- SEARCH BAR -->
              <div id="searchBar" class="col">
                <div class="input-group">
                  <input v-model="search_id" class="form-control" type="text" placeholder="Search booking by ID" aria-label="default input example">
                  <div class="input-group-append">
                    <button id="submitBookingBtn" class="btn btn-light" type="submit" @click="search">Search</button>
                  </div>
                </div>
                <div v-if="page.showInvalid.searchBtn" class="invalid-entry" id="searchInvalid">
                {{ search_invalid }}
                </div>
              </div>
            </div>

            <!-- Booking entry information -->
            <BookingEntry ref="bookingEntry" v-for="booking in this.$store.state.bookings"
                          :key="booking._id"
                          :bookingId="booking._id"
                          :booking-count="get_bookings_array.indexOf(booking) + 1"
                          :status="booking.status"
                          :name="booking.person.name"
                          :mobile="booking.person.mobile"
                          :restaurant="booking.restaurant.name"
                          :date="new Date(booking.restaurant.date).toDateString()"
                          :time="booking.restaurant.time"
                          :pax="booking.restaurant.pax"
                          :notes="booking.person.notes"
                          @edit_clicked="onClickEdit(booking._id)"
                          @delete_clicked="onClickDelete(booking._id)">
            </BookingEntry>
          </div>
        </div>

        <!-- CONTACT US -->
        <div class="row">
          <ContactForm />
        </div>

        <!-- FOOTER CONTENT -->
        <div>
          <Footer />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import NavBar from "../components/NavBar"
import MainHeader from "../components/MainHeader"
import ContactForm from "../components/ContactForm"
import Footer from "../components/Footer"
import BookingEntry from "../components/BookingEntry"
import ModalWindow from "../components/ModalWindow"
import HourglassIcon from "../components/HourglassIcon"
import Notification from "../components/Notification"

export default {
  name: "Bookings",
  components: {
    HourglassIcon,
    NavBar,
    MainHeader,
    ContactForm,
    Footer,
    BookingEntry,
    ModalWindow,
    Notification
  },
  data() {
    return {
      selected: "name",
      edit_input: "",
      left_message: "",
      right_message: "",
      search_id: null,
      item_id: null,
      response: null,
      invalid_note: null,
      search_invalid: null,
      mainHeader: {
        main_text: "Manage your bookings"
      },
      edit_window: {
        title: "Edit Booking",
        body: "Select item to edit and enter the information in the text field below. " +
            "\nClick the confirm edit button to finalise your request."
      },
      delete_window: {
        title: "Delete Booking",
        body: "Click the confirmation button to finalise the deletion of your booking."
      },
      response_window: {
        title: "",
        body: ""
      },
      page: {
        showEdit: false,
        showDelete: false,
        showResponse: false,
        showHourGlass: false,
        showInvalid: {
          searchBtn: false,
          confirmEditBtn: false
        }
      }
    }
  },
  created() {
    this.$store.dispatch('getBookings');
  },
  computed: {
    get_bookings_array() {
      return this.$store.getters.bookings_array
    },
    get_search_id() {
      return this.search_id
    },
    get_selected_value() {
      return this.selected
    },
    get_edit_input() {
      return this.edit_input
    }
  },
  methods: {
    // Open edit confirmation window
    onClickEdit(objectId) {
      this.page.showEdit = !this.page.showEdit;
      this.item_id = objectId;
    },

    // Open delete confirmation window
    onClickDelete(objectId) {
      this.page.showDelete = !this.page.showDelete;
      this.item_id = objectId;
    },

    // Update booking
    confirmEdit() {
      let validation = true;
      this.page.showInvalid.confirmEditBtn = false;

      // Validate user input is not empty
      if (this.edit_input === "") {
        this.invalid_note = "The input cannot be empty.";
        this.page.showInvalid.confirmEditBtn = true;
        validation = false;
      }

      // Validate user "name" input does not contain invalid characters
      else if (this.selected === "name" && !this.edit_input.match(/^[a-zA-Z ]+$/)) {
        this.invalid_note = "The guest name cannot contain invalid characters.";
        this.page.showInvalid.confirmEditBtn = true;
        validation = false;
      }

      // Validate user "mobile" input is a valid Australian mobile number
      else if (this.selected === "mobile" && (this.edit_input.slice(0,2) !== "04" || this.edit_input.length !== 10)) {
        this.invalid_note = "The mobile number must be a valid 10-digit Australian mobile number.";
        this.page.showInvalid.confirmEditBtn = true;
        validation = false;
      }

      // Validate user "pax" input is a number and is from 1 to 12
      else if (this.selected === "pax" && (isNaN(this.edit_input) || this.edit_input > 12 || this.edit_input < 1)) {
        this.invalid_note = "The number of guests can only be between 1 to 12";
        this.page.showInvalid.confirmEditBtn = true;
        validation = false;
      }

      // Validate user "notes" input has a maximum character length of 100
      else if (this.selected === "notes" && this.edit_input.length > 100) {
        this.invalid_note = "The character limit is 100.";
        this.page.showInvalid.confirmEditBtn = true;
        validation = false;
      }

      // If validation passes, send PUT request to update the booking
      if (validation === true) {
        this.page.showInvalid.confirmEditBtn = false;

        let object;
        if (this.get_selected_value === "pax") {
          object = "restaurant"
        } else {
          object = "person"
        }

        let data = {
          [object]: {
            [this.get_selected_value]: this.get_edit_input
          }
        }

        fetch("http://localhost:3000/bookings/" + this.item_id, {
          method: 'PUT',
          mode: 'cors',
          headers: {
            'Content-Type': 'application/json'
          },
          body: JSON.stringify(data)
        })
            .then(async res => {
              this.page.showEdit = !this.page.showEdit;
              this.page.showHourGlass = !this.page.showHourGlass;

              // Set response text
              let resJson = await res.json();

              if (!res.ok) {
                // Error response window
                this.response_window.title = "Edit Error";
                this.response_window.body = resJson.errors[0].msg;
              } else {
                // Success response window
                this.response_window.title = "Edit Request"
                this.response_window.body = resJson.messages[0].msg;
              }

              setTimeout(() => {
                this.page.showHourGlass = !this.page.showHourGlass;
                this.page.showResponse = !this.page.showResponse;
              }, 5000);
            })
            .catch(err => console.log(err))
      }
    },

    // Delete booking
    confirmDelete() {
      fetch("http://localhost:3000/bookings/" + this.item_id, {
        method: "DELETE"
      })
          .then(async res => {
            this.page.showDelete = !this.page.showDelete;
            this.page.showHourGlass = !this.page.showHourGlass;

            // Set response text
            let resJson = await res.json();

            if (!res.ok) {
              // Error response window
              this.response_window.title = "Deletion Error";
              this.response_window.body = resJson.errors[0].msg;
            } else {
              // Success response window
              this.response_window.title = "Deletion Request"
              this.response_window.body = resJson.messages[0].msg;
            }

            setTimeout(() => {
              this.page.showHourGlass = !this.page.showHourGlass;
              this.page.showResponse = !this.page.showResponse;
            }, 5000);
          })
          .catch(err => console.log(err))
    },

    // Search booking by id
    search() {
      // Validate that search input is valid ObjectId
      if (this.get_search_id === null || !this.get_search_id.match(/^[0-9a-fA-F]{24}$/)) {
        this.search_invalid = "Please enter a valid booking ID.";
        this.page.showInvalid.searchBtn = true;
      }
      else {
        this.page.showInvalid.searchBtn = false;

        fetch("http://localhost:3000/bookings/" + this.get_search_id, {
          method: "GET"
        })
            .then(async res => {
              this.page.showHourGlass = !this.page.showHourGlass;

              // Set search result text
              let resJson = await res.json();

              if (!res.ok) {
                // Error response window
                this.response_window.title = "Search Error";
                this.response_window.body = resJson.errors[0].msg;
              } else {
                // Success response window
                this.left_message =
                    "Booking ID: " +
                    "\nBooking Status: " +
                    "\nName: " +
                    "\nMobile Number: " +
                    "\nRestaurant Name: " +
                    "\nDate: " +
                    "\nTime: " +
                    "\nNumber of Guests: " +
                    "\nAdditional Notes: ";
                this.right_message =
                    resJson._id +
                    "\n" + resJson.status +
                    "\n" + resJson.person.name +
                    "\n" + resJson.person.mobile +
                    "\n" + resJson.restaurant.name +
                    "\n" + new Date(resJson.restaurant.date).toDateString() +
                    "\n" + resJson.restaurant.time +
                    "\n" + resJson.restaurant.pax +
                    "\n" + resJson.person.notes;
                this.response_window.title = "Search Result";
              }

              setTimeout(() => {
                this.page.showHourGlass = !this.page.showHourGlass;
                this.page.showResponse = !this.page.showResponse;
              }, 2000);
            })
            .catch(err => console.log(err))
      }
    },

    closeResponse() {
      this.page.showResponse = false;
      // Reload page after closing response window
      location.reload();
    }
  }
}
</script>

<style scoped>
p {
  color: #a5a5a5;
}

a {
  text-decoration: none;
}

select {
  color: #6d6d6d;
  border:none;
  background-color: transparent;
}

svg {
  color: #886565;
}

.pre-formatted {
  white-space: pre;
}

.btn {
  color: #584141;
  background-color: #f3f3f3;
  border-color: #c6c6c6;
}

.btn:hover {
  background-color: #a97c7c;
  color: #f6ede3;
}

.button-container {
  display: flex;
  justify-content: right;
}

.card-header {
  color: #9b7272;
  padding: 2rem 0;
  background-color: transparent;
  border: transparent;
  margin: 1rem 2rem 0 2rem;
}

.invalid-entry {
  display: block;
  color: #d02b2b;
  font-size: small;
  margin: 0.5rem 0;
  float: right;
}

#middleRow {
  padding: 2rem;
  margin-left: 1rem;
  margin-bottom: 4rem;
}

#searchBar {
  padding: 3rem;
}

#searchResult {
  width: 30rem;
}

@media (max-width: 900px) {
  .card-header {
    margin: 0 2rem 0 2rem;
  }

  #searchBar {
    padding: 2rem 1rem;
    min-width: 15rem;
  }

  #searchResult {
    width: 25rem;
    font-size: small;
  }
}

@media (max-width: 500px) {
  .card-header {
    margin: 0.5rem 2rem 0 2rem;
  }

  #searchBar {
    padding: 0 1rem;
    min-width: 15rem;
  }

  #middleRow {
    width: 25rem;
    margin-left: 0;
    padding-left: 0;
  }
}
</style>